use crate::{errors::RunError, execute, parse, stack::StackVec, Stack};
use std::fs;

pub fn args(memory: &mut StackVec, origin_stack: &mut Option<&mut Stack>, data: u16) {
    if let Some(origin_stack) = origin_stack.as_mut() {
        let mut data = data;

        if data == 0 {
            data = origin_stack.memory.pop();
        }

        for _ in 0..data {
            memory.push(origin_stack.memory.pop());
        }
    } else {
        eprintln!("{}", RunError::RequestArgsInMainModule);
        std::process::exit(2);
    }
}

pub fn exec(mut stack: &mut Stack, arg: String, mod_name: String) {
    if mod_name == arg {
        eprintln!("{}", RunError::ExecuteItself(arg.to_string()));
        std::process::exit(2);
    }

    let lines = fs::read_to_string(&arg).expect(&format!("{}", RunError::FailToReadFile));
    let mut temp_stack = Stack::new(stack.memory.size());

    parse(&mut temp_stack, &lines);
    execute(&mut temp_stack, Some(&mut stack), arg.clone());

    for item in temp_stack.memory.iter() {
        stack.memory.push(*item);
    }
}
